﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace MainForm
{
    /// <summary>
    /// Interaction logic for HeadWin.xaml
    /// </summary>
    public partial class HeadWin : Window
    {
        private List<Border> borderList = new List<Border>();

        public HeadWin()
        {
            InitializeComponent();
            borderList.Add(border00);
            borderList.Add(border01);
            borderList.Add(border02);
            borderList.Add(border10);
            borderList.Add(border11);
            borderList.Add(border12);
            borderList.Add(border20);
            borderList.Add(border21);
            borderList.Add(border22);
        }

        private void border00_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {


            foreach (Border border in borderList)
            {
                if (border.Name != "border00")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border00.BorderBrush = Brushes.Yellow;
        }

        private void border01_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {

            foreach (Border border in borderList)
            {
                if (border.Name != "border01")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }

            border01.BorderBrush = Brushes.Yellow;
        }

        private void border02_MouseLeftButtonDown_1(object sender, MouseButtonEventArgs e)
        {
            foreach (Border border in borderList)
            {
                if (border.Name != "border02")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border02.BorderBrush = Brushes.Yellow;
        }

        private void border10_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            foreach (Border border in borderList)
            {
                if (border.Name != "border10")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border10.BorderBrush = Brushes.Yellow;
        }

        private void border11_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            foreach (Border border in borderList)
            {
                if (border.Name != "border11")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border11.BorderBrush = Brushes.Yellow;
        }

        private void border12_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            foreach (Border border in borderList)
            {
                if (border.Name != "border12")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border12.BorderBrush = Brushes.Yellow;
        }

        private void border20_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            foreach (Border border in borderList)
            {
                if (border.Name != "border20")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border20.BorderBrush = Brushes.Yellow;
        }

        private void border21_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            foreach (Border border in borderList)
            {
                if (border.Name != "border21")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border21.BorderBrush = Brushes.Yellow;
        }

        private void border22_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            foreach (Border border in borderList)
            {
                if (border.Name != "border22")
                {
                    border.BorderBrush = Brushes.Blue;
                }
            }
            border22.BorderBrush = Brushes.Yellow;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
            this.Close();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            this.DialogResult = true;
            Register.num = getSelectedHead();
            this.Close();
        }

        private int getSelectedHead()
        {
            int num = 0;
            foreach (Border border in borderList)
            {
                if (border.BorderBrush == Brushes.Yellow)
                {
                    return num;
                }
                else
                {
                    num++;
                }
            }

            return num;
        }


    }
}
