﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace MainForm
{
    /// <summary>
    /// Interaction logic for OptionWin.xaml
    /// </summary>
    public partial class OptionWin : Window
    {
        public OptionWin()
        {
            InitializeComponent();
        }

        private void musicSelect_Loaded(object sender, RoutedEventArgs e)
        {
            List<string> musics = new List<string>();
            musics.Add("秋日的私语");
            musics.Add("卡农");
            musics.Add("梦中的婚礼");

            musicSelect.ItemsSource = musics;
            musicSelect.SelectedIndex = 0;
        }

        private void mostGrade_Loaded(object sender, RoutedEventArgs e)
        {
            mostGrade.Content = "您目前的最高成绩为" + 500 + "米!";
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            this.DragMove();
        }

        private void confine_Click(object sender, RoutedEventArgs e)
        {
            saveMsg();
        }

        private void saveMsg()
        {
            string str = "" + volumeSlider.Value + "/" + musicSelect.SelectedValue + "/" + mostGrade.Content + "/";

            bool? check0 = receiveBox.IsChecked;
            if (check0 == true)
            {
                str += "yes";
            }
            else
            {
                str += "no";
            }

            bool? share = shareBox.IsChecked;
            if (share == true)
            {
                str += "/yes";
            }
            else
            {
                str += "/no";
            }

            using (FileStream fs = new FileStream("msg.txt", FileMode.Create))
            {
                using (StreamWriter writer = new StreamWriter(fs, Encoding.UTF8))
                {
                    writer.Write(str);
                }
            }

            this.Close();
        }

    }
}
