﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using WPFMediaKit.DirectShow.Controls;
using System.Windows.Threading;
using System.Threading;

namespace MainForm
{
    /// <summary>
    /// Interaction logic for StartWin.xaml
    /// </summary>
    public partial class StartWin : Window
    {
        /*
         *摄像头 
         * 
         */
        public static byte[] data_f;
        calculate kaikai;

        public static int width, height;
        int numBit = 15;
        int[] res_5 = new int[15];
        int pace = 0;
        int last = 0, index = 0, index1 = 0;
        private bool isMonitor = true;
        public static bool isJump = false;
        public int last_speed = 0;
        private int mile = 0;
        private int temp = 0;
        private bool jump1 = false;
        /*
            *摄像头 
            * 
            */

        public int SCREEN_WIDTH = (int)SystemParameters.PrimaryScreenWidth;
        public int SCREEN_HEIGHT = (int)SystemParameters.PrimaryScreenHeight;

        const double RATIO_HW = 846 / 500;
        const double TAN28 = 0.6;
        const double MULTI = 1.01;
        private bool isPause = false;
        private List<Image> snows = new List<Image>();
        private int num = 0;

        //static Image[] array = new Image[25];


        int road_count = 1;
        int character_count = 1;
        //int soil_count = 1;
        int jump_count = 1;
        //int tree_count = 1;
        DispatcherTimer roadThread = new DispatcherTimer();
        DispatcherTimer characterThread = new DispatcherTimer();

        DispatcherTimer jumpChararcterThread = new DispatcherTimer();
        DispatcherTimer treeThread = new DispatcherTimer();
        DispatcherTimer snowThread = new DispatcherTimer();
        DispatcherTimer scoreboardThread = new DispatcherTimer();

        //DispatcherTimer soilThread = new DispatcherTimer();

        static int speed = 1;

        public StartWin()
        {
            InitializeComponent();
            Canvas.SetLeft(showCanvas, SCREEN_WIDTH - showCanvas.Width);
            Canvas.SetTop(showCanvas, SCREEN_HEIGHT - showCanvas.Height);

            //Video.vce = new VideoCaptureElement();
            Video.vce.BeginInit();
            Video.vce.Height = 122;
            Video.vce.Width = 140;
            Video.vce.Stretch = Stretch.Fill;
            Video.vce.EndInit();
            root.Children.Add(Video.vce);

            /*
            *摄像头 
            * 
            */
            kaikai = new calculate();
            for (int aa = 0; aa < numBit; aa++)
                res_5[aa] = 0;
            /*
            *摄像头 
            * 
            */


                road.Source = new BitmapImage(new Uri(@"image\road\1.png", UriKind.Relative));
            character.Source = new BitmapImage(new Uri(@"image\character\man01\1.png", UriKind.Relative));


            tree_L0.Source = new BitmapImage(new Uri(@"image\tree\tree0.png", UriKind.Relative));
            tree_L1.Source = new BitmapImage(new Uri(@"image\tree\tree00.png", UriKind.Relative));
            tree_L2.Source = new BitmapImage(new Uri(@"image\tree\tree00.png", UriKind.Relative));
            tree_L3.Source = new BitmapImage(new Uri(@"image\tree\tree00.png", UriKind.Relative));

            tree_R0.Source = new BitmapImage(new Uri(@"image\tree\tree0.png", UriKind.Relative));
            tree_R1.Source = new BitmapImage(new Uri(@"image\tree\tree00.png", UriKind.Relative));
            tree_R2.Source = new BitmapImage(new Uri(@"image\tree\tree00.png", UriKind.Relative));
            tree_R3.Source = new BitmapImage(new Uri(@"image\tree\tree00.png", UriKind.Relative));

            background.Source = new BitmapImage(new Uri(@"image\background0.png", UriKind.Relative));
            background.Width = SystemParameters.PrimaryScreenWidth;
            Canvas.SetTop(background, 0);

            Carrier.Height = windows.Height;
            Carrier.Width = windows.Width;
            road.Width = 1024;

            tree_L0.Width = 30;
            tree_L1.Width = 80;
            tree_L2.Width = 130;
            tree_L3.Width = 180;

            tree_R0.Width = 30;
            tree_R1.Width = 80;
            tree_R2.Width = 130;
            tree_R3.Width = 180;

            Canvas.SetTop(scoreBoard, 0);
            Canvas.SetLeft(scoreBoard, SystemParameters.FullPrimaryScreenWidth / 3);

            Canvas.SetLeft(road, 200);
            Canvas.SetBottom(road, 0);
            Canvas.SetLeft(character, 570);
            Canvas.SetBottom(character, 50);

            Canvas.SetLeft(tree_L0, 680);
            Canvas.SetTop(tree_L0, 350);
            Canvas.SetLeft(tree_L1, 560);
            Canvas.SetTop(tree_L1, 390);
            Canvas.SetLeft(tree_L2, 500);
            Canvas.SetTop(tree_L2, 420);
            Canvas.SetLeft(tree_L3, 400);
            Canvas.SetTop(tree_L3, 450);

            Canvas.SetRight(tree_R0, 630);
            Canvas.SetTop(tree_R0, 350);
            Canvas.SetRight(tree_R1, 530);
            Canvas.SetTop(tree_R1, 390);
            Canvas.SetRight(tree_R2, 420);
            Canvas.SetTop(tree_R2, 420);
            Canvas.SetRight(tree_R3, 300);
            Canvas.SetTop(tree_R3, 460);

            Canvas.SetTop(scoreBoard, 0);
            Canvas.SetLeft(scoreBoard, 0);

            initSnow();
            setSnows();

            character.Width = 300;

            runTheRoad();
            runTheCharacter();
            //stopTheRoad();
            runTheTree();
            runTheSnow();
            refreshScoreboard();

           jumpChararcterThread.Tick += new EventHandler(jumpCharacterThread_Tick);

            Thread thread = new Thread(new ThreadStart(ThreadProc));
            thread.Start();

        }

        private void startAll()
        {
            runTheCharacter();
            runTheRoad();
            runTheTree();
        }

        private void stopAll()
        {
            stopTheCharacter();
            stopTheRoad();
            stopTheTree();
        }

        //private 
        private void refreshScoreboard()
        {
            scoreboardThread.Interval = TimeSpan.FromMilliseconds(10);
            scoreboardThread.Tick += new EventHandler(scoreboardThread_Tick);
            scoreboardThread.Start();
        }

        private void scoreboardThread_Tick(object sendor, EventArgs e)
        {
           // 跑步热量（kcal）＝体重（kg）×距离（公里）×1.036 
             mile = num / 30;
            double col = 65 * mile * 0.001 * 1.036;
            string myStr = col.ToString("0.00");
            col = Convert.ToDouble(myStr);

            temp = (int)(col*10);
            passData(mile, temp);
        }

        private void passData(int dis, int cal)
        {
            int dis1, dis2, dis3, dis4;

            dis1 = dis / 1000;
            dis2 = (dis - 1000 * dis1) / 100;
            dis3 = (dis - dis1 * 1000 - dis2 * 100) / 10;
            dis4 = dis - dis1 * 1000 - dis2 * 100 - dis3 * 10;


            dis_1.Source = new BitmapImage(new Uri(@"num/" + dis1 + ".png", UriKind.Relative));
            dis_2.Source = new BitmapImage(new Uri(@"num/" + dis2 + ".png", UriKind.Relative));
            dis_3.Source = new BitmapImage(new Uri(@"num/" + dis3 + ".png", UriKind.Relative));
            dis_4.Source = new BitmapImage(new Uri(@"num/" + dis4 + ".png", UriKind.Relative));

            int cal1, cal2, cal3, cal4;

            cal1 = cal / 1000;
            cal2 = (cal - 1000 * cal1) / 100;
            cal3 = (cal - cal1 * 1000 - cal2 * 100) / 10;
            cal4 = cal - cal1 * 1000 - cal2 * 100 - cal3 * 10;


            cal_1.Source = new BitmapImage(new Uri(@"num/" + cal1 + ".png", UriKind.Relative));
            cal_2.Source = new BitmapImage(new Uri(@"num/" + cal2 + ".png", UriKind.Relative));
            cal_3.Source = new BitmapImage(new Uri(@"num/" + cal3 + ".png", UriKind.Relative));
            cal_4.Source = new BitmapImage(new Uri(@"num/" + cal4 + ".png", UriKind.Relative));
        }
        private void runTheRoad()
        {
            roadThread.Tick += new EventHandler(roadThread_Tick);
            roadThread.Start();
        }

        private void runAll()
        {
            roadThread.Start();
            characterThread.Start();
            treeThread.Start();
        }

        private void stopTheRoad()
        {
            roadThread.Stop();
            //road.Source = new BitmapImage(new Uri(@"image\road\1.gif", UriKind.Relative));
        }

        private void roadThread_Tick(object sendor, EventArgs e)
        {
            if (speed != 0)
                roadThread.Interval = TimeSpan.FromMilliseconds(700 / speed);

            road.Source = new BitmapImage(new Uri(@"image\road\" + road_count + ".png", UriKind.Relative));
            road_count = road_count == 6 ? 1 : road_count + 1;

            num++;
        }


        private void runTheCharacter()
        {
            characterThread.Tick += new EventHandler(characterThread_Tick);
            // characterThread.Interval = TimeSpan.FromMilliseconds(10 / speed);
            characterThread.Start();
        }

        private void stopTheCharacter()
        {
            characterThread.Stop();
            //character.Source = new BitmapImage(new Uri(@"image\character\1.gif", UriKind.Relative));
        }

        private void jumpTheCharacter()
        {
            stopTheCharacter();
            // jumpChararcterThread.Tick += new EventHandler(jumpCharacterThread_Tick);
            jumpChararcterThread.Start();
            jump_count = 1;
        }

        private void jumpCharacterThread_Tick(object sendor, EventArgs e)
        {
            stopTheCharacter();
                jumpChararcterThread.Interval = TimeSpan.FromMilliseconds(150);
            character.Source = new BitmapImage(new Uri(@"image\character\man01\jump\" + jump_count + ".png", UriKind.Relative));
            if (jump_count == 7)
            {
                jump_count = 1;
                jumpChararcterThread.Stop();
                // runTheCharacter();
                characterThread.Start();
            }
            else
            {
                jump_count++;
                //stopTheCharacter();
            }
            //Console.Write(" " + jump_count);

        }



        private void characterThread_Tick(object sendor, EventArgs e)
        {
            if (speed != 0)
                characterThread.Interval = TimeSpan.FromMilliseconds(1000 / speed);
            character.Source = new BitmapImage(new Uri(@"image\character\man01\" + character_count + ".png", UriKind.Relative));
            //Console.Write(" " + speed);
            character_count = character_count == 25 ? 1 : character_count + 1;
        }
        private void runTheTree()
        {
            treeThread.Tick += new EventHandler(treeThread_Tick);
            treeThread.Start();

        }

        //double treeLeftTemp = 0;
        private void MoveTheLeftTree(Image tree)
        {

            if (speed != 0)
                treeThread.Interval = TimeSpan.FromMilliseconds(600 / speed);

            if (Canvas.GetLeft(tree) < 370 && Canvas.GetLeft(tree) >= 50)
            {
                double tree_X = Canvas.GetLeft(tree);
                double tree_Y = Canvas.GetTop(tree);

                double moveDown = 2;
                tree.Width *= 1.008;
                double moveRight = moveDown / TAN28;
                Canvas.SetLeft(tree, tree_X - moveRight * 1.6);
                Canvas.SetTop(tree, tree_Y + moveDown);

            }
            else if (Canvas.GetLeft(tree) < 50)
            {
                Random num = new Random();
                int mm = num.Next(1);
                tree.Source = new BitmapImage(new Uri(@"image\tree\tree" + mm + ".png", UriKind.Relative));

                tree.Width = 30;
                Canvas.SetLeft(tree, 680);
                Canvas.SetTop(tree, 340);

            }
            else
            {


                double tree_X = Canvas.GetLeft(tree);
                double tree_Y = Canvas.GetTop(tree);
                tree.Width *= MULTI;
                double temp_width = tree.Width;
                double moveDown = 0.1;
                double moveRight = (moveDown / TAN28 + 2 * (tree.Width * MULTI - tree.Width)) / 1.1;
                Canvas.SetLeft(tree, tree_X - moveRight);
                Canvas.SetTop(tree, tree_Y + 13.5 * moveDown - tree.Width * (MULTI - 1));

                //Console.Write("x : " + Canvas.GetLeft(tree) + " y : " + Canvas.GetTop(tree));
            }
        }

        private void MoveTheRightTree(Image tree)
        {
            if (speed != 0)
                treeThread.Interval = TimeSpan.FromMilliseconds(600 / speed);

            if (Canvas.GetRight(tree) < 370 && Canvas.GetRight(tree) >= 50)
            {
                double tree_X = Canvas.GetRight(tree);
                double tree_Y = Canvas.GetTop(tree);
                //tree.Width *= MULTI;
                //double temp_width = tree.Width;
                tree.Width *= 1.008;
                double moveDown = 2;
                double moveRight = moveDown / TAN28;
                Canvas.SetRight(tree, tree_X - moveRight * 1.6);
                Canvas.SetTop(tree, tree_Y + moveDown);

            }


            else if (Canvas.GetRight(tree) < 50)
            {
                Random num = new Random();
                int mm = num.Next(1);
                tree.Source = new BitmapImage(new Uri(@"image\tree\tree" + mm + ".png", UriKind.Relative));

                tree.Width = 30;
                Canvas.SetRight(tree, 630);
                Canvas.SetTop(tree, 340);

            }
            else
            {
                double tree_X = Canvas.GetRight(tree);
                double tree_Y = Canvas.GetTop(tree);
                tree.Width *= MULTI;
                double temp_width = tree.Width;
                double moveDown = 0.1;
                double moveRight = (moveDown / TAN28 + 2 * (tree.Width * MULTI - tree.Width)) / 1.1;
                Canvas.SetRight(tree, tree_X - moveRight);
                Canvas.SetTop(tree, tree_Y + 13.5 * moveDown - tree.Width * (MULTI - 1));

                //Console.Write("x : " + Canvas.GetLeft(tree) + " y : " + Canvas.GetTop(tree));
            }
        }

        private void treeThread_Tick(object sensor, EventArgs e)
        {

            MoveTheLeftTree(tree_L0);
            MoveTheLeftTree(tree_L1);
            MoveTheLeftTree(tree_L2);
            MoveTheLeftTree(tree_L3);

            MoveTheRightTree(tree_R0);
            MoveTheRightTree(tree_R1);
            MoveTheRightTree(tree_R2);
            MoveTheRightTree(tree_R3);
        }

        private void stopTheTree()
        {
            treeThread.Stop();
        }



        private void Window_Loaded(object sender, RoutedEventArgs e)
        {


            int nStyle = Win32API.GetWindowLong(new WindowInteropHelper(this).Handle, Win32API.GWL_STYLE);
            nStyle &= ~Win32API.WS_CAPTION;
            Win32API.SetWindowLong(new WindowInteropHelper(this).Handle, Win32API.GWL_STYLE, nStyle);

            /*
             *摄像头 
             * 
             */

            if (MultimediaUtil.VideoInputNames.Length > 0)
            {
                Video.vce.VideoCaptureSource = MultimediaUtil.VideoInputNames[1];
            }
            else
            {
                MessageBox.Show("未检测到任何可用摄像头!");
            }
            /*
             * 
             *摄像头 
             */

            
        }

        public class Win32API
        {
            public const int GWL_STYLE = -16;
            public const int GWL_EXSTYLE = -20;
            public const int WS_CAPTION = 0x00C00000;
            [DllImport("user32.dll")]
            public static extern int
            SetWindowLong(IntPtr hWnd, int nIndex, int New);
            [DllImport("user32.dll")]
            public static extern int GetWindowLong(IntPtr hWnd, int nIndex);
        }

        private void Pause_Click(object sender, RoutedEventArgs e)
        {
            if (isPause == false)
            {
                stopAll();
                isPause = true;
            }
            else
            {
                startAll();
                isPause = false;
            }

        }

        private void Exit_Click(object sender, RoutedEventArgs e)
        {
            stopAll();
            isMonitor = false;
            //Application.Current.
            Video.vce.Stop();
            Video.vce.Close();
            Video.vce.VideoCaptureSource = null;
            root.Children.Remove(Video.vce);

            GradeShowWin grade = new GradeShowWin(mile, temp);
            grade.ShowDialog();

            this.Close();
        }

        private void windows_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.W)
            {
                speed = 500;
            }
            else if (e.Key == Key.Up)
            {
                jumpTheCharacter();
            }
            else if (e.Key == Key.S)
            {
                //speed = 1;
                stopAll();
            }

        }

      

        //开启一个新的线程，用于实时数据的处理和传递
        void ThreadProc()
        {
            RenderTargetBitmap bmp2 = null;
            this.Dispatcher.Invoke(new Action(() => { bmp2 = new RenderTargetBitmap((int)Video.vce.ActualWidth, (int)Video.vce.ActualHeight, 96, 96, PixelFormats.Default); }));
            Int32Rect a;
            int stride;
            byte[] data = null;
            while (isMonitor)
            {
                //bmp2.Render(vce1);
                this.Dispatcher.Invoke(new Action(() =>
                {
                    bmp2.Render(Video.vce);
                    a = new Int32Rect(0, 0, bmp2.PixelWidth, bmp2.PixelHeight);
                    a = new Int32Rect(0, 0, bmp2.PixelWidth, bmp2.PixelHeight);
                    stride = bmp2.Format.BitsPerPixel * a.Width / 8;
                    data = new byte[a.Height * stride];
                    bmp2.CopyPixels(a, data, stride, 0);
                }));

                kaikai.toBinary(data_f, data); //二值化

                //这是图像的开运算，用于图像的处理，用于降噪点
                kaikai.Corrosion();
                kaikai.expand();

                //寻找出谷底的位置
                kaikai.findValley();

                last = kaikai.finddiff();   //计算差值

                jump1 = kaikai.isjump();
                if (jump1 == true)
                {
                    Console.WriteLine("I am Jumping!!!");
                    jumpTheCharacter();
                    
                }
                   

                //用于方差计算，提高数据的稳定性
                if ((last - res_5[index]) > 70)    //避免大的波动
                {
                    last = last - 40;
                }

                if ((last - res_5[index]) < -70)
                {
                    last = last + 40;
                }
                index = (index + 1) % numBit;
                res_5[index] = last;

                Variance(res_5);   //计算方差

                Thread.Sleep(70);
            }
        }
        /////////////////////////////////////////////////////////////////////////////////////
        //每次根据num个点计算出方差，以近似的计算出数值的变化频率，进一步代表时间
        /////////////////////////////////////////////////////////////////////////////////////
        void Variance(int[] res)
        {
            int ava = 0, fangcha = 0, medium;
            for (int i = 0; i < numBit; i++)
                ava += res[i];
            ava /= numBit;
            for (int i = 0; i < numBit; i++)
            {
                medium = res[i] - ava;
                fangcha += medium * medium;
            }
            //Console.Write("速度" + fangcha/num/100);
            if (index1++ < numBit / 2)
            {
                // Console.Write("速度" + fangcha / num / 100);
                pace += fangcha / numBit / 100;
            }
            else
            {
                //Console.Write("pace：" + pace + "   \n");
               
                speed = pace*2;
                if (speed == 0)
                {
                    stopAll();
                }
                else runAll();

                last_speed = speed;//跟新上一次的速度值

                index1 = 0;
                pace = 0;
            }
            // Console.Write();
        }

        private void initSnow()
        {
            snow0.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow1.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow2.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow3.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow4.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow5.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow6.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow7.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow8.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow9.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow10.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow11.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow12.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow13.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow14.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));
            snow15.Source = new BitmapImage(new Uri(@"image\Scene1\snow.png", UriKind.Relative));

            snows.Add(snow0);
            snows.Add(snow1);
            snows.Add(snow2);
            snows.Add(snow3);
            snows.Add(snow4);
            snows.Add(snow5);
            snows.Add(snow6);
            snows.Add(snow7);
            snows.Add(snow8);
            snows.Add(snow9);
            snows.Add(snow10);
            snows.Add(snow11);
            snows.Add(snow12);
            snows.Add(snow13);
            snows.Add(snow14);
            snows.Add(snow15);
        }

        private void setSnow(Image snow)
        {
            Random ran = new Random();
            snow.Width = ran.Next(50) + 20; ;
            snow.Height = snow.Width;
            Canvas.SetTop(snow, ran.Next(100));
            Canvas.SetLeft(snow, ran.Next(SCREEN_WIDTH));
        }

        private void setSnows()
        {
            Random ran = new Random();

            snow0.Width = ran.Next(50) + 20; ;
            snow0.Height = snow0.Width;
            Canvas.SetTop(snow0, ran.Next(200));
            Canvas.SetLeft(snow0, ran.Next(SCREEN_WIDTH));

            snow1.Width = ran.Next(50) + 20; ;
            snow1.Height = snow1.Width;
            Canvas.SetTop(snow1, ran.Next(200));
            Canvas.SetLeft(snow1, ran.Next(SCREEN_WIDTH));

            snow2.Width = ran.Next(50) + 20; ;
            snow2.Height = snow2.Width;
            Canvas.SetTop(snow2, ran.Next(200));
            Canvas.SetLeft(snow2, ran.Next(SCREEN_WIDTH));

            snow3.Width = ran.Next(50) + 20; ;
            snow3.Height = snow3.Width;
            Canvas.SetTop(snow3, ran.Next(200));
            Canvas.SetLeft(snow3, ran.Next(SCREEN_WIDTH));

            snow4.Width = ran.Next(50) + 20; ;
            snow4.Height = snow4.Width;
            Canvas.SetTop(snow4, ran.Next(200));
            Canvas.SetLeft(snow4, ran.Next(SCREEN_WIDTH));

            snow5.Width = ran.Next(50) + 20; ;
            snow5.Height = snow5.Width;
            Canvas.SetTop(snow5, ran.Next(200));
            Canvas.SetLeft(snow5, ran.Next(SCREEN_WIDTH));

            snow6.Width = ran.Next(50) + 20; ;
            snow6.Height = snow7.Width;
            Canvas.SetTop(snow6, ran.Next(200));
            Canvas.SetLeft(snow6, ran.Next(SCREEN_WIDTH));

            snow7.Width = ran.Next(50) + 20; ;
            snow7.Height = snow7.Width;
            Canvas.SetTop(snow7, ran.Next(200));
            Canvas.SetLeft(snow7, ran.Next(SCREEN_WIDTH));

            snow8.Width = ran.Next(50) + 20; ;
            snow8.Height = snow8.Width;
            Canvas.SetTop(snow8, ran.Next(200));
            Canvas.SetLeft(snow8, ran.Next(SCREEN_WIDTH));

            snow9.Width = ran.Next(50) + 20; ;
            snow9.Height = snow9.Width;
            Canvas.SetTop(snow9, ran.Next(200));
            Canvas.SetLeft(snow9, ran.Next(SCREEN_WIDTH));

            snow10.Width = ran.Next(50) + 20; ;
            snow10.Height = snow10.Width;
            Canvas.SetTop(snow10, ran.Next(200));
            Canvas.SetLeft(snow10, ran.Next(SCREEN_WIDTH));

            snow11.Width = ran.Next(50) + 20; ;
            snow11.Height = snow11.Width;
            Canvas.SetTop(snow11, ran.Next(200));
            Canvas.SetLeft(snow11, ran.Next(SCREEN_WIDTH));

            snow12.Width = ran.Next(50) + 20; ;
            snow12.Height = snow12.Width;
            Canvas.SetTop(snow12, ran.Next(200));
            Canvas.SetLeft(snow12, ran.Next(SCREEN_WIDTH));

            snow13.Width = ran.Next(50) + 20; ;
            snow13.Height = snow13.Width;
            Canvas.SetTop(snow13, ran.Next(200));
            Canvas.SetLeft(snow13, ran.Next(SCREEN_WIDTH));

            snow14.Width = ran.Next(50) + 20; ;
            snow14.Height = snow14.Width;
            Canvas.SetTop(snow14, ran.Next(200));
            Canvas.SetLeft(snow14, ran.Next(SCREEN_WIDTH));

            snow15.Width = ran.Next(50) + 20; ;
            snow15.Height = snow15.Width;
            Canvas.SetTop(snow15, ran.Next(200));
            Canvas.SetLeft(snow15, ran.Next(SCREEN_WIDTH));
        }

        private void snowThread_Tick(object sendor, EventArgs e)
        {
            foreach (Image img in snows)
            {
                moveSnow(img);
            }

            //的方式V的V
        }

        private void moveSnow(Image snow)
        {

            snowThread.Interval = TimeSpan.FromMilliseconds(1);

            if (Canvas.GetTop(snow) > SCREEN_HEIGHT)
            {
                setSnow(snow);
            }
            else
            {
                Canvas.SetTop(snow, Canvas.GetTop(snow) + 1);
            }
        }

        private void runTheSnow()
        {
            snowThread.Tick += new EventHandler(snowThread_Tick);
            // characterThread.Interval = TimeSpan.FromMilliseconds(10 / speed);
            snowThread.Start();
        }
        
    }
}