﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace MainForm
{
    /// <summary>
    /// Interaction logic for GradeShowWin.xaml
    /// </summary>
    public partial class GradeShowWin : Window
    {
        int miles = 0;
        int cols = 0;
        public GradeShowWin(int miles,int cols)
        {
            InitializeComponent();
            this.miles = miles;
            this.cols = cols;

            mileBlock.Text = "您这次跑了 " + miles + " 米!坚持奥!";
            int c1 = cols / 10;
            int c2 = cols % 10;
            colBlock.Text = "消耗了 " + c1 + "." + c2 + "卡路里!";

            string temp = c1 + "." + c2;
            double mice = Convert.ToDouble(temp);
            double miceCol = mice * 0.9;
            miceBlock.Text = "相当于消耗了 " + miceCol + "克";

            double chickenCol = mice * 0.4;
            beefBlock.Text = "相当于消耗了 " + chickenCol + "克";
        }

        private void confineBtn_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }


        private void concelBtn_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            string str = Environment.CurrentDirectory;
            str += "\\share\\share.html";
            web.Navigate(str);
        }
    }
}
