﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MainForm
{
    static class ProAndCity
    {
        static string[] provinStr = { "北京市", "天津市", "上海市", "重庆市", "河北省", "山西省", "辽宁省", "吉林省",
                                     "黑龙江省", "江苏省", "浙江省", "安徽省", "福建省", "江西省", "山东省", "河南省", "湖南省", "湖北省", 
                                     "广东省", "海南省", "四川省", "贵州省", "云南省", "陕西省", "甘肃省", "青海省", "台湾省", "西藏自治区", 
                                     "内蒙古自治区", "广西壮族自治区", "宁夏回族自治区", "新疆维吾尔自治区"};


        static string[] beijingCity = { "北京市" };
        static string[] tianjinCity = { "天津市" };
        static string[] shanghaiCity = { "上海市" };
        static string[] chongqingCity = { "重庆市" };
        static string[] hebeiCity = { "石家庄", "唐山", "秦皇岛", "邯郸", "邢台", "保定", "张家口", "承德", "沧州", "廊坊", "衡水" };
        static string[] xishanCity = { "太原市", "大同市", "阳泉市", "长治市", "晋城市", "朔州市", "晋中市", "运城市", "忻州市", "临汾市", "吕梁市" };
        static string[] liaoningCity = { "沈阳市", "大连市", "鞍山市", "抚顺市", "本溪市", "丹东市", "锦州市", "营口市", "阜新市", "辽阳市", "盘锦市", "铁岭市", "朝阳市", "葫芦岛" };
        static string[] jilinCiy = { "长春市", "吉林市", "四平市", "辽源市", "通化市", "白山市", "白城市", "松原市" };
        static string[] heilongjiangCity = { "哈尔滨", "齐齐哈尔", "牡丹江", "佳木斯", "大庆", "伊春", "鸡西", "鹤岗", "双鸭山", "七台河", "绥化", "黑河", "大兴安岭" };
        static string[] jiangsuCity = { "南京市", "无锡市", "徐州市", "常州市", "苏州市", "南通市", "连云港", "淮安市", "盐城市", "扬州市", "镇江市", "泰州市", "宿迁市" };
        static string[] zhejiangCity = {"杭州市","宁波市","温州市","绍兴市","湖州市","嘉兴市","金华市","衢州市","舟山市","丽水市","义乌市"};
        static string[] anhuiCity = {"合肥市","六安市","芜湖市","黄山市","蚌埠市","阜阳市","淮南市","滁州市","马鞍山市","宣城市","池州市","宿州市","淮北市","毫州市","安庆市","铜陵市"};
        static string[] fujianCity = { "福州", "厦门", "漳州", "泉州", "三明", "莆田", "南平", "龙岩", "宁德市", "平潭县" };
        static string[] jiangxiCity = { "南昌市", "九江市", "上饶市", "抚州市", "宜春市", "吉安市", "赣州市", "景德镇", "萍乡", "新余", "鹰潭" };
        static string[] shandongCity = {"济南市","青岛市","淄博市","枣庄市","东营市","烟台市","潍坊市","济宁市","泰安市",
                                   "威海市","日照市","滨州市","德州市","聊城市","临沂市","菏泽市","莱芜市"};
        static string[] henanCity = {"郑州市","开封市","洛阳市","平顶山","安阳市","鹤壁市","新乡市","焦作市","濮阳市","许昌市","漯河市","三门峡"
                                    ,"商丘市","周口市","驻马店","南阳市","信阳市","济源市"};
        static string[] hunanCity = {"长沙市","株洲市","湘潭市","衡阳市","邵阳市","岳阳市","张家界市","益阳市","常德市","娄底市",
                                    "郴州市","永州市","怀化市","西乡土家族苗族自治区"};
        static string[] hubeiCity = {"武汉市","黄石市","十堰市","荆州市","宜昌市","襄阳市",
                                     "鄂州市","荆门市","黄冈市","孝感市","咸宁市","仙桃市","潜江市","神农架林区","恩施土家族苗族自治州","天门市","随州市"};
        static string[] guangdongCity = {"广州","深圳","珠海","汕头","佛山","韶关","湛江","肇庆","江门","茂名","惠州","梅州","汕尾","河源","阳江","清远","东莞","中山","潮州","揭阳","云浮"};
        static string[] hainanCity = { "海口市", "三亚市", "三沙市" };
        static string[] sichuanCity = {"成都市","绵阳市","自贡市","攀枝花市","泸州市","德阳市","广元市","遂宁市","内江市","乐山市",
                                      "资阳市","宜宾市","南充市","达州市","雅安市","阿坝藏族羌族自治州","甘孜藏族自治州","凉山藏族自治州","广安市","巴中市","眉山市"};
        static string[] guizhouCity = { "贵阳市", "六盘水市", "遵义市", "铜仁市", "黔西南布依族苗族州", "毕节市", "安顺市", "黔东南苗族侗族州", "黔南布依族苗族州" };
        static string[] yunnanCity = {"昆明市","曲靖市","玉溪市","保山市","昭通市","丽江市","普洱市","临沧市",
                                     "德宏傣族景颇族自治州","怒江僳僳族自治州","迪庆藏族自治州","大理白族自治州","楚雄彝族自治州","红河哈尼族彝族自治州","文山壮族苗族自治州","西双版纳傣族自治州"};

        static string[] shanxiCity = {"西安市","宝鸡市","咸阳市","渭南市","铜川市","延安市","榆林市","安康市","汉中市","商洛市"};
        static string[] gansuCity = { "兰州市","酒泉市","金昌市","天水市","嘉峪关","武威市","张掖市",
                                    "白银市","平凉市","庆阳市","定西市","陇南市","临夏自治州","甘南自治州"};
        static string[] qinghaiCity = { "西宁市", "海东市", "海北藏族自治州", "黄南藏族自治州", "海南藏族自治州", "果洛藏族自治州", "玉树藏族自治州", "海西蒙古族藏族自治州" };
        static string[] taiwanCity = {"台北市","新北市","台中市","台南市","高雄市","桃园县","新竹县","苗粟县","彰化县","南投县","云林县",
                                     "嘉义县","屏东县","宜兰县","花莲县","台东县","澎湖县","金门县","连江县","基隆市","新竹市","嘉义市"};

        static string[] xizangCity = { "拉萨市", "昌都地区", "林芝地区", "山南地区", "日喀则地区", "那曲地区", "阿里地区" };
        static string[] neimengCity = {"呼和浩特市","包头市","乌海市","赤峰市","通辽市","鄂尔多斯市",
                                      "呼伦贝尔市","巴彦淖尔市","乌兰察布市","兴安盟","锡林郭勒盟","阿拉善盟"};
        static string[] guangxiCity = {"南宁市","柳州市","桂林市","梧州市","北海市","钦州市","防城港市",
                                      "贵港市","玉林市","百色市","河池市","贺州市","来宾市","崇左市"};
        static string[] ningxiaCity = { "银川市", "石嘴山市", "吴忠市", "固原市", "中卫市" };
        static string[] xinjiangCity = { "乌鲁木齐市","克拉玛依市","吐鲁番地区","哈密地区","昌吉回族自治州","博尔塔拉蒙古自治州","巴音郭楞蒙古自治州","阿克苏地区","克孜勒苏柯尔克孜自治州","喀什地区","和田地区","伊犁哈萨克自治州",
                                       "塔城地区","阿勒泰地区","石河子市","阿拉尔市","图木舒克市","五家渠市","北屯市","铁门关市","双河市"};


        public static List<string> getProv(){
         List<string> provinceList = new List<string>();
         provinceList = provinStr.ToList();
         return provinceList;
       }



        public static List<string> getbeijingCity()
        {
            List<string> beijingCityList = new List<string>();
            beijingCityList = beijingCity.ToList();
            return beijingCityList;
        }

        public static List<string> gettianjinCity()
        {
            List<string> tianjinCityList = new List<string>();
            tianjinCityList = tianjinCity.ToList();
            return tianjinCityList;
        }
        public static List<string> getshanghaiCity()
        {
            List<string> shanghaiCityList = new List<string>();
            shanghaiCityList = shanghaiCity.ToList();
            return shanghaiCityList;
        }

        public static List<string> getchongqingCity()
        {
            List<string> chongqingCityList = new List<string>();
            chongqingCityList = chongqingCity.ToList();
            return chongqingCityList;
        }
        public static List<string> gethebeiCity()
        {
            List<string> hebeiCityList = new List<string>();
            hebeiCityList = hebeiCity.ToList();
            return hebeiCityList;
        }
        public static List<string> getxishanCity()
        {
            List<string> xishanCityList = new List<string>();
            xishanCityList = xishanCity.ToList();
            return xishanCityList;
        }
        public static List<string> getliaoningCity()
        {
            List<string> liaoningCityList = new List<string>();
            liaoningCityList = liaoningCity.ToList();
            return liaoningCityList;
        }
        public static List<string> getjilinCity()
        {
            List<string> jilinCiyList = new List<string>();
            jilinCiyList = jilinCiy.ToList();
            return jilinCiyList;
        }
        public static List<string> getheilongjiangCity()
        {
            List<string> heilongjiangCityList = new List<string>();
            heilongjiangCityList = heilongjiangCity.ToList();
            return heilongjiangCityList;
        }
        public static List<string> getjiangsuCity()
        {
            List<string> jiangsuCityList = new List<string>();
            jiangsuCityList = jiangsuCity.ToList();
            return jiangsuCityList;
        }
        public static List<string> getzhejiangCity()
        {
            List<string> zhejiangCityList = new List<string>();
            zhejiangCityList = zhejiangCity.ToList();
            return zhejiangCityList;
        }
        public static List<string> getanhuiCity()
        {
            List<string> anhuiCityList = new List<string>();
            anhuiCityList = anhuiCity.ToList();
            return anhuiCityList;
        }
        public static List<string> getfujianCity()
        {
            List<string> fujianCityList = new List<string>();
            fujianCityList = fujianCity.ToList();
            return fujianCityList;
        }
        public static List<string> getjiangxiCity()
        {
            List<string> jiangxiCityList = new List<string>();
            jiangxiCityList = jiangxiCity.ToList();
            return jiangxiCityList;
        }
        public static List<string> getshandongCity()
        {
            List<string> shandongCityList = new List<string>();
            shandongCityList = shandongCity.ToList();
            return shandongCityList;
        }
        public static List<string> gethenanCity()
        {
            List<string> henanCityList = new List<string>();
            henanCityList = henanCity.ToList();
            return henanCityList;
        }
        public static List<string> gethunanCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = hunanCity.ToList();
            return provinceList;
        }
        public static List<string> gethubeiCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = hubeiCity.ToList();
            return provinceList;
        }
        public static List<string> getguangdongCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = guangdongCity.ToList();
            return provinceList;
        }
        public static List<string> gethainanCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = hainanCity.ToList();
            return provinceList;
        }
        public static List<string> getgansuCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = gansuCity.ToList();
            return provinceList;
        }
        public static List<string> getsichuanCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = sichuanCity.ToList();
            return provinceList;
        }
        public static List<string> getguizhouCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = guizhouCity.ToList();
            return provinceList;
        }
        public static List<string> getyunnanCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = yunnanCity.ToList();
            return provinceList;
        }
        public static List<string> getshanxiCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = shanxiCity.ToList();
            return provinceList;
        }
        public static List<string> getqinghaiCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = qinghaiCity.ToList();
            return provinceList;
          
       }
        public static List<string> gettaiwanCity()
        {
         List<string> provinceList = new List<string>();
         provinceList = taiwanCity.ToList();
         return provinceList;

       }

        public static List<string> getxizangCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = xizangCity.ToList();
            return provinceList;

        }

        public static List<string> getneimengCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = neimengCity.ToList();
            return provinceList;

        }

        public static List<string> getguangxiCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = guangxiCity.ToList();
            return provinceList;

        }

        public static List<string> getningxiaCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = ningxiaCity.ToList();
            return provinceList;

        }

        public static List<string> getxinjiangCity()
        {
            List<string> provinceList = new List<string>();
            provinceList = xinjiangCity.ToList();
            return provinceList;

        }
        
    }
}
