﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Threading;

namespace MainForm
{
    /// <summary>
    /// Register.xaml 的交互逻辑
    /// </summary>
    public partial class Register : Window
    {
        NetworkStream upStream = null;
        public static string fileName = null;
        public static int num = 0;
        private string tempPath = null;
        //private bool isConneted = true;

        private ProgressionBar msgbox = null;

        public static byte[] fileBytes = null;
        

        public Register()
        {
            InitializeComponent();
        }

        public Register(NetworkStream stream)
        {
            InitializeComponent();
            upStream = stream;

            Thread thread = new Thread(new ThreadStart(run));
            thread.IsBackground = true;
            thread.Start();
        }

        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            this.DragMove();
        }

        private void close_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void Window_Initialized(object sender, EventArgs e)
        {

            combo_Province.ItemsSource = ProAndCity.getProv();
        }

        private void combo_city_GotFocus(object sender, RoutedEventArgs e)
        {
            
        }

        private void combo_Province_LostFocus(object sender, RoutedEventArgs e)
        {           
            if (combo_Province.SelectedValue == "北京市")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getbeijingCity();
            }
            else if (combo_Province.SelectedValue == "天津市")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.gettianjinCity();
            }
            else if (combo_Province.SelectedValue == "上海市")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getshanghaiCity();
            }
            else if (combo_Province.SelectedValue == "重庆市")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getchongqingCity();
            }
            else if (combo_Province.SelectedValue == "河北省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.gethebeiCity();
            }
            else if (combo_Province.SelectedValue == "山西省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getxishanCity();
            }
            else if (combo_Province.SelectedValue == "辽宁省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getliaoningCity();
            }
            else if (combo_Province.SelectedValue == "吉林省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getjilinCity();
            }
            else if (combo_Province.SelectedValue=="黑龙江省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getheilongjiangCity();
            }
            else if (combo_Province.SelectedValue == "江苏省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getjiangsuCity();
            }
            else if (combo_Province.SelectedValue == "浙江省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getzhejiangCity();
            }
            else if (combo_Province.SelectedValue == "安徽省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getanhuiCity();
            }
            else if (combo_Province.SelectedValue == "福建省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getfujianCity();
            }
            else if (combo_Province.SelectedValue == "江西省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getjiangxiCity();
            }
            else if (combo_Province.SelectedValue == "山东省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getshandongCity();
            }
            else if (combo_Province.SelectedValue == "河南省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.gethenanCity();
            }
            else if (combo_Province.SelectedValue == "湖南省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.gethunanCity();
            }
            else if (combo_Province.SelectedValue == "湖北省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.gethubeiCity();
            }
            else if (combo_Province.SelectedValue == "广东省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getguangdongCity();
            }
            else if (combo_Province.SelectedValue == "海南省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.gethainanCity();
            }
            else if (combo_Province.SelectedValue == "四川省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getsichuanCity();
            }
            else if (combo_Province.SelectedValue == "贵州省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getguizhouCity();
            }
            else if (combo_Province.SelectedValue == "云南省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getyunnanCity();
            }
            else if (combo_Province.SelectedValue == "陕西省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getshanxiCity();
            }
            else if (combo_Province.SelectedValue == "甘肃省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getgansuCity();
            }
            else if (combo_Province.SelectedValue == "台湾省")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.gettaiwanCity();
            }
            else if (combo_Province.SelectedValue == "西藏自治区")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getxizangCity();
            }
            else if (combo_Province.SelectedValue == "内蒙古自治区")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getneimengCity();
            }
            else if (combo_Province.SelectedValue == "广西壮族自治区")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getguangxiCity();
            }
            else if (combo_Province.SelectedValue == "宁夏回族自治区")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getningxiaCity();
            }
            else if (combo_Province.SelectedValue == "新疆维吾尔自治区")
            {
                combo_city.ItemsSource = MainForm.ProAndCity.getxinjiangCity();
            }else {
                combo_city.ItemsSource = null;
            }
        }


        private void btn_cancel_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void btn_admit_Click(object sender, RoutedEventArgs e)
        {
            string name = txtbox_username.Text;
            string firpasswd = firstPass.Password;
            string secpasswd = secondPass.Password;

            if (firpasswd != secpasswd)
            {
                MessageBox.Show("两次密码输入不一致，请重新输入!");
                return;
            }

            bool? sexMale = rbtn_male.IsChecked;
            bool? sexFemale = rbtn_female.IsChecked;
            string  sex = null;
            if (sexMale != null || sexFemale != null)
            {
                if (sexMale == true)
                {
                    sex = "男";
                }
                else {
                    sex = "女";
                }
            }
            else {
                MessageBox.Show("您没有选中性别，请您重新选择!");
                return;
            }

            DateTime? dateTime = birDate.SelectedDate;
            string date = null;
            if (dateTime != null)
            {
                date = dateTime.ToString();
            }
            else {
                MessageBox.Show("您还没有选择您的生日，请重新选择!");
                return;
            }

            string place = (string)combo_Province.SelectedItem;
            place += (string)combo_city.SelectedItem;

            if (place == null)
            {
                MessageBox.Show("您没有选择您的出生地点，请重新选择!!");
                return;
            }

            string email = emailBox.Text;
            if (email == null)
            {
                MessageBox.Show("您没有输入您的邮箱，请重新输入!!");
                return;
            }


            if (upStream.CanWrite)
            {

                if (!File.Exists(tempPath))
                {
                    MessageBox.Show("注册失败,请稍候重试!");
                    return;
                }

               
                    using (FileStream fs = new FileStream("F:\\abc1.jpg", FileMode.Create))
                    {
                        fs.Write(fileBytes, 0, fileBytes.Length);
                    }


                    int size = fileBytes.Length;

                string msg = size + "%%%%%" + name + "%%%%%" + firpasswd + "%%%%%" + sex + "%%%%%" + date + "%%%%%" + place + "%%%%%" + email + "%%%%%";
                byte[] bytes = Encoding.Unicode.GetBytes(msg);

                //bytes.Concat(fileBytes);

                byte[] sendData = new byte[bytes.Length + fileBytes.Length];
                bytes.CopyTo(sendData, 0);
                fileBytes.CopyTo(sendData, bytes.Length);

                upStream.Write(sendData, 0, sendData.Length);

                msgbox = new ProgressionBar();
                msgbox.ShowDialog();
                //MessageBox.Show("已发送!");
            }

           // this.Close();


        }

        private void btn_opencamera_Click(object sender, RoutedEventArgs e)
        {
            PhotoTakeWin photoWin = new PhotoTakeWin();
            bool? showOr = photoWin.ShowDialog();
            if (showOr == true)
            {
                //MessageBox.Show("shshshs");
                if (Register.fileName != null)
                {
                    tempPath = System.AppDomain.CurrentDomain.BaseDirectory + Register.fileName;

                    ima_head.Source = new BitmapImage(new Uri(tempPath, UriKind.Absolute));
                }
            }
        }

        private void btn_fromsystem_Click(object sender, RoutedEventArgs e)
        {
            HeadWin headWin = new HeadWin();
            bool? showOr = headWin.ShowDialog();
            if (showOr == true)
            {
                if (Register.num != 0)
                {
                    string path = "/headImage/" + (num+1) + ".jpg";

                    tempPath = System.Environment.CurrentDirectory;
                    int len = tempPath.Length;
                    len -= 10;
                    tempPath = tempPath.Remove(len);
                    tempPath += path;
                    //path = tempPath;

                    FileStream fs = File.Open(tempPath, FileMode.Open);
                    //声明一个byte数组接受图片byte信息
                    Register.fileBytes = new byte[fs.Length];

                    using (fs)
                    {
                        //将图片byte信息读入byte数组中
                        fs.Read(Register.fileBytes, 0, Register.fileBytes.Length);
                        fs.Close();
                    }

                   ima_head.Source = new BitmapImage(new Uri(path, UriKind.Relative));
                }
            }
        }

        private void run()
        {
            while (true)
            {
                if (MainWindow.regSuccess == 1)
                {
                    this.Dispatcher.Invoke(new Action(() =>
                    {
                        MessageBox.Show("注册成功!");
                        msgbox.Close();
                        this.Close();
                    }));
                    MainWindow.regSuccess = 0;
                }
                else if (MainWindow.regSuccess == 2)
                {
                    this.Dispatcher.Invoke(new Action(() =>
                    {
                        msgbox.Close();
                        MessageBox.Show("注册失败!请重新注册!");
                    }));
                    MainWindow.regSuccess = 0;
                }
                else { 
                
                }
            }
        }
    }
}
